.data

V:  .space 48
D:  .space 48
S:  .space 10

printf1: .asciiz "Inserire un numero positivo\n"
printf2: .asciiz "Inserire una stringa di almeno 6 numeri\n"
printfD: .asciiz "D[%d]=%d\n"

printf_addr: .space 8
i: .space 8
Di: .space 8

par_let: .word 0
ind: .space 8
dim: .word 10


.code
; rispetto alla versione precedente il codice  schedulato in modo
; da minimizzare i data hazard
 
 
 
 ;inizializzazione della stringa da stampare nel ciclo di lettura
 daddi r10, r0, printf1
 daddi r8, r0, 0    ; r8=i=0  
 daddi r9, r0, 48   ; r9=dimensione vettore V
 sd r10, printf_addr(r0)
 
 
 ciclo_lettura:
   ;printf("Inserire un numero positivo\n");
   daddi r14, r0, printf_addr
   syscall 5
   
   ;scanf("%d",&V[i]);
   jal input_unsigned
   sd r1, V(r8)
   ;i++
   daddi r8,r8, 8
   ;while(i!=6);
   bne r8, r9, ciclo_lettura
   
  ;inizializzazione della stringa da stampare nella lettura della stringa 
  daddi r10, r0, printf2  
  ;inizializzazione parametri syscall 3 per la lettura della stringa S
  daddi r11, r0, S
  sd r10, printf_addr(r0) 
  sd r11, ind(r0)
  
    
  lettura_stringa: 
    ;printf("Inserire una stringa di almeno 6 numeri");
    daddi r14, r0, printf_addr
    syscall 5
    
    ;scanf("%s",S);
    daddi r14, r0, par_let
    syscall 3
    
    ;while(strlen(S)<6);
    slti r12, r1, 6
    bne r12, r0, lettura_stringa
    
    
  daddi r8, r0, 0    ; r8=i=0 indice di S
  daddi r9, r0, 0    ; r9 indice di V e D
  daddi r10, r0, 48   ; r10=dimensione vettore V e D
  
  ciclo_elabora:
      lb r16, S(r8)   ; r16=S[i]
      ld r17, V(r9)   ; r17=V[i]
      daddi r16, r16, -48
      dmult r16, r17
      mflo r17
      sd r17, D(r9)
      daddi r9, r9, 8
      daddi r8,r8,1
      bne r9, r10, ciclo_elabora
      
 ;visualizzazione 
  
   ;inizializzazione della stringa da stampare nel ciclo di visualizzazione 
  daddi r10, r0, printfD  
  sd r10, printf_addr(r0) 
  daddi r14, r0, printf_addr
   
  daddi r9, r0, 0    ; r9 indice di D
  daddi r10, r0, 48   ; r10=dimensione vettore D
 
  
  ciclo_visualizzazione:
     beq r9, r10, fine
     dsra r11,r9, 3    ;  r11=r9/8 e' l'indice da stampare 
     ld r12, D(r9)
     daddi r9, r9, 8  
     sd r11, i(r0)
     sd r12, Di(r0)
     syscall 5
     j ciclo_visualizzazione
     
 fine: syscall 0
  
 
#include input-unsigned.s

