
.data

vettore:  .space 40
vettore2:  .space 40


par_write:   .word 1
ind: .space 8
num_byte: .word 8

stampa: .asciiz "V[ %d ] = %d\n"
stampa_addr: .space 8
i: .space 8
vi: .space 8

prompt: .asciiz "Inserisci un numero\n"
prompt_addr: .space 8

Sr6: .space 8
Sr7: .space 8
Sr8: .space 8
Sr9: .space 8
Sr16: .space 8

stack: .space 80


.code
;inizializzazione del puntatore alla cima dello stack di 80 byte 
daddi r29, r0, stack
daddi r29, r29, 80

; chiamata a leggi vettore 
daddi r5, r0,prompt
sd r5, prompt_addr(r0)
; inizializzazione dei parametri da passare alla procedura leggi_vettore
daddi r2, r0, vettore ; nel parametro r2  indirizzo vettore
daddi r3, r0, 5		  ; nel parametro r3  numero di valori da leggere 
daddi r4, r0, prompt_addr	; nel parametro r4 l'indirizzo del prompt da visualizzare

jal leggi_vettore

; chiamata a stampa
daddi r5, r0,stampa
sd r5, stampa_addr(r0)
; inizializzazione dei parametri da passare alla procedura visualizza_vettore
daddi r2, r0, vettore	; nel parametro r2  indirizzo vettore
daddi r3, r0, 5			; nel parametro r3  numero di valori da visualizzare
daddi r4, r0, stampa_addr  ; ; nel parametro r4 l'indirizzo della stringa da visualizzare

jal visualizza_vettore
syscall 0


;-----------------------------------

leggi_vettore:

 ; r2: indirizzo vettore da leggere
 ; r3: numero elementi
 ; r4  indirizzo della stringa da visualizzare 
 
 sd r6, Sr6(r0)
 sd r7, Sr7(r0)
 daddi r29, r29, -8
 sd r31, 0 (r29)


lettura:
        
 daddi r6, r0, 0
 dadd r7, r0, r3 ;  r7= num elementi
 dsll  r7,r7, 3   ;  R7= r7*8= numero totale di byte
 
 ciclo_lettura:
    dadd r14, r0, r4
    syscall 5
    
 
    jal input_unsigned
    
    
    sd r1, vettore(r6)
    daddi  r6,r6,8
    bne r6, r7, ciclo_lettura
    
    ld r31, 0(r29)
    daddi r29, r29, 8
  
  jr r31  
; ---------fine leggi_vettore -------------          






; -----------------------------
visualizza_vettore:
                   
                   
 ; r2: indirizzo vettore da visualizzare
 ; r3: numero elementi
 ; r4: indirizzo stampa_addr
 
 sd r6, Sr6(r0)
 sd r7, Sr7(r0)
 sd r8, Sr8(r0)
 sd r9, Sr9(r0)
 sd r16, Sr16(r0)

 sd r2, ind(r0)
   
 
 daddi r6, r0, 0  ;  r6=i=0
 dadd r7, r0, r3 ;  r7= num elementi
 dsll  r7,r7, 3   ;  R7= r7*8= numero totale di byte
 daddi r8, r0, 0
 
 
 loop:
   
    
    sd r8, 8 (r4) ; salva r8 in i
    dadd r9, r6, r2 ; calcola  vettore + i
    ld r16, 0 (r9)   ; legge vettore[i]
    sd r16, 16 (r4)  ; salva vettore[i] in vi
    
    dadd r14, r0, r4  ; mette in r14 il valore di stampa_addr
    syscall 5
    daddi r6,r6, 8
    daddi r8, r8, 1
    bne r6, r7, loop
    
    
 ld r6, Sr6(r0)
 ld r7, Sr7(r0)
 ld r8, Sr8(r0)
 ld r9, Sr9(r0)
 ld r16, Sr16(r0)

    
 jr r31     
;------------------------------------------- 
 
#include input-unsigned.s
 
 
 
 
                   
 
 
                   






